#include "/sys/ins/base.ins.c"
#include "/sys/ins/ios.ins.c"

#include "v2.h"
#include "v2d.h"

extern status_$t unix_fio_$status;

v2_$get(hpp, optp, bp, buf_lenp, stp)
v2_handle_t **hpp;
ios_$put_get_opts_t *optp;
char *bp;
long *buf_lenp;
status_$t *stp;
{
	v2_handle_t *hp = *hpp;

	if (hp->type != v2f_$uid) {
		stp->all = ios_$illegal_obj_type;
		return 0;
	}
	return v2_$i_get(hp, *optp, bp, *buf_lenp, stp);
}

v2_$i_get(hp, opt, bp, buf_len, stp)
v2_handle_t *hp;
ios_$put_get_opts_t opt;
char *bp;
long buf_len;
status_$t *stp;
{
	int i, n;

	stp->all = status_$ok;

	v2_$real_seek(hp);
	if (opt & ios_$no_rec_bndry_opt)
		putlong(C_READ);
	else
		putlong(C_RDLN);
	putlong(buf_len);
	n = getlong();
	if (n < 0) {
		stp->all = v2_tr_errno(n);
		return 0;
	}
	if (n == 0) {
		stp->all = ios_$end_of_file;
		return 0;
	}
	if ((i = getbytes(bp, n)) < 0) {
		stp->all = v2_tr_errno(i);
		return 0;
	}
	hp->seek_key += i;
	return i;
}
